function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import { createBatchMemoizer } from './cache-util';
test('createBatchMemoizer even inline func can be cached',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var memoizer, runCount, r1, r2;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          memoizer = createBatchMemoizer();
          runCount = 0;
          r1 = memoizer.newBatch({}).memoize(function () {
            runCount++;
            return {
              x: []
            };
          });
          r2 = memoizer.newBatch({}).memoize(function () {
            runCount++;
            return {
              x: []
            };
          });
          expect(r1.x).toBe(r2.x);
          expect(runCount).toBe(1);

        case 6:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this);
})));