"use strict";

var _map2 = _interopRequireDefault(require("lodash/map"));

var _searchObjects = _interopRequireDefault(require("./searchObjects"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

test('basic',
/*#__PURE__*/
_asyncToGenerator(
/*#__PURE__*/
regeneratorRuntime.mark(function _callee() {
  var docs, defaultConf, search;
  return regeneratorRuntime.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          docs = [{
            name: 'Chan Tai Man'
          }, {
            name: 'S4何香江'
          }, {
            name: 'To To Wong'
          }, {
            name: 'To Wong',
            mobile: '123456'
          }, {
            name: 'Book',
            price: 12.3
          }, {
            name: 'Book S4',
            price: 12
          }];
          defaultConf = ['name', 'mobile', 'price'];

          search = function search(searchStr) {
            return (0, _map2.default)((0, _searchObjects.default)(docs, searchStr, defaultConf), 'name');
          };

          expect(search('Ta Ma')).toEqual(['Chan Tai Man']);
          expect(search('To')).toEqual(['To Wong', 'To To Wong']);
          expect(search('To To')).toEqual(['To To Wong', 'To Wong']);
          expect(search('123456')).toEqual(['To Wong']);
          expect(search('何香江')).toEqual(['S4何香江']);
          expect(search('S4')).toEqual(['S4何香江', 'Book S4']);
          expect(search('12')).toEqual(['Book S4', 'Book', 'To Wong']);
          expect((0, _searchObjects.default)(null, '')).toEqual([]);
          expect((0, _searchObjects.default)(docs, '')).toEqual(docs);

        case 12:
        case "end":
          return _context.stop();
      }
    }
  }, _callee, this);
})));